'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _class, _temp, _initialiseProps;

var _validator = require('../utils/validator');

var _validator2 = _interopRequireDefault(_validator);

var _listening = require('./listening');

var _listening2 = _interopRequireDefault(_listening);

var _formField = require('./formField');

var _formField2 = _interopRequireDefault(_formField);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Form = (_temp = _class = function (_Listening) {
  _inherits(Form, _Listening);

  function Form(_ref) {
    var schema = _ref.schema,
        _ref$onSubmit = _ref.onSubmit,
        onSubmit = _ref$onSubmit === undefined ? null : _ref$onSubmit,
        _ref$onChange = _ref.onChange,
        onChange = _ref$onChange === undefined ? null : _ref$onChange;

    _classCallCheck(this, Form);

    var _this = _possibleConstructorReturn(this, (Form.__proto__ || Object.getPrototypeOf(Form)).call(this));

    _initialiseProps.call(_this);

    _this.schema = schema;
    _this.onSubmit = onSubmit;
    _this.onChange = onChange;

    var _loop = function _loop(name) {
      var _schema$name = schema[name],
          _schema$name$defaultV = _schema$name.defaultValue,
          defaultValue = _schema$name$defaultV === undefined ? null : _schema$name$defaultV,
          _schema$name$validati = _schema$name.validation,
          validation = _schema$name$validati === undefined ? null : _schema$name$validati;


      var field = new _formField2.default({ defaultValue: defaultValue });
      field.setValue(defaultValue);
      field.on('change', function (formField) {
        return _this.onChangeField(name, formField);
      });

      _this.defaultData[name] = defaultValue;
      if (validation !== null) {
        _this.validationSchema.properties[name] = validation;
      }
      _this.fields[name] = field;
    };

    for (var name in schema) {
      _loop(name);
    }

    _this.validate();
    return _this;
  }

  return Form;
}(_listening2.default), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.schema = {};
  this.defaultData = {};
  this.fields = {};
  this.submitted = false;
  this.valid = true;
  this.onSubmit = null;
  this.onChange = null;
  this.validationSchema = {
    properties: {}
  };

  this.onChangeField = function (name, formField) {
    _this2.validate();
    _this2.trigger('change', _this2);
    if (_this2.onChange !== null) {
      _this2.onChange(_this2);
    }
  };

  this.submit = function () {
    var event = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

    if (event !== null && 'preventDefault' in event) {
      event.preventDefault();
    }
    if (!_this2.valid) {
      if (!_this2.submitted) {
        _this2.submitted = true;
        _this2.trigger('change', _this2);
      }
      return;
    }
    _this2.submitted = true;
    _this2.trigger('submit', _this2);
    if (_this2.onSubmit !== null) {
      var formData = _this2.getFormData();
      _this2.onSubmit(formData, _this2);
    }
  };

  this.validate = function () {
    var data = {};

    for (var name in _this2.fields) {
      data[name] = _this2.fields[name].value;
    }
    var schema = _this2.validationSchema;
    var validation = _validator2.default.validate(data, schema);
    _this2.valid = validation.valid;

    var fieldsError = {};
    validation.errors.forEach(function (error) {
      fieldsError[error.property] = error;
    });

    for (var _name in _this2.fields) {
      if (_name in fieldsError) {
        _this2.fields[_name].setValidation(false, fieldsError[_name].message);
      } else {
        _this2.fields[_name].setValidation(true, null);
      }
    }
  };

  this.getFormData = function () {
    var formData = {};

    for (var name in _this2.fields) {
      formData[name] = _this2.fields[name].value;
    }

    return formData;
  };

  this.reset = function () {
    _this2.submitted = false;

    var _loop2 = function _loop2(name) {
      var field = _this2.fields[name];
      field.off('change');
      field.reset();
      field.on('change', function (formField) {
        return _this2.onChangeField(name, formField);
      });
    };

    for (var name in _this2.fields) {
      _loop2(name);
    }

    _this2.validate();
  };
}, _temp);
exports.default = Form;