'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _listening = require('./listening');

var _listening2 = _interopRequireDefault(_listening);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormField = function (_Listening) {
  _inherits(FormField, _Listening);

  function FormField(_ref) {
    var defaultValue = _ref.defaultValue;

    _classCallCheck(this, FormField);

    var _this = _possibleConstructorReturn(this, (FormField.__proto__ || Object.getPrototypeOf(FormField)).call(this));

    _this.value = null;
    _this.valid = true;
    _this.changed = false;
    _this.errorMessage = null;
    _this.defaultValue = undefined;

    _this.setValue = function (value) {
      _this.value = value;
      _this.trigger('change', _this);
    };

    _this.setValidation = function (valid) {
      var errorMessage = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      _this.valid = valid;
      _this.errorMessage = errorMessage;
    };

    _this.change = function () {
      var event = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

      if (event !== null && 'target' in event && 'value' in event.target) {
        _this.changed = true;
        _this.setValue(event.target.value);
      }
    };

    _this.changeValue = function (value) {
      _this.changed = true;
      _this.setValue(value);
    };

    _this.reset = function () {
      _this.changed = false;
      _this.setValue(_this.defaultValue);
    };

    _this.defaultValue = defaultValue;
    return _this;
  }

  return FormField;
}(_listening2.default);

exports.default = FormField;