'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _desc, _value, _class, _descriptor, _descriptor2, _descriptor3, _descriptor4;

var _unenumerable = require('./unenumerable');

var _unenumerable2 = _interopRequireDefault(_unenumerable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var Listening = (_class = function Listening() {
  _classCallCheck(this, Listening);

  _initDefineProp(this, 'eventHandlers', _descriptor, this);

  _initDefineProp(this, 'on', _descriptor2, this);

  _initDefineProp(this, 'off', _descriptor3, this);

  _initDefineProp(this, 'trigger', _descriptor4, this);
}, (_descriptor = _applyDecoratedDescriptor(_class.prototype, 'eventHandlers', [_unenumerable2.default], {
  enumerable: true,
  initializer: function initializer() {
    return {};
  }
}), _descriptor2 = _applyDecoratedDescriptor(_class.prototype, 'on', [_unenumerable2.default], {
  enumerable: true,
  initializer: function initializer() {
    var _this = this;

    return function (event, handler) {
      if (!(event in _this.eventHandlers)) {
        _this.eventHandlers[event] = [];
      }

      _this.eventHandlers[event].push(handler);
    };
  }
}), _descriptor3 = _applyDecoratedDescriptor(_class.prototype, 'off', [_unenumerable2.default], {
  enumerable: true,
  initializer: function initializer() {
    var _this2 = this;

    return function (event) {
      var handler = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      if (!(event in _this2.eventHandlers)) {
        return;
      }

      if (handler === null) {
        _this2.eventHandlers[event] = [];
      } else {
        _this2.eventHandlers[event] = _this2.eventHandlers[event].filter(function (x) {
          return handler;
        });
      }
    };
  }
}), _descriptor4 = _applyDecoratedDescriptor(_class.prototype, 'trigger', [_unenumerable2.default], {
  enumerable: true,
  initializer: function initializer() {
    var _this3 = this;

    return function (event, data) {
      if (!(event in _this3.eventHandlers)) {
        return;
      }
      _this3.eventHandlers[event].forEach(function (handler) {
        return handler(data);
      });
    };
  }
})), _class);
exports.default = Listening;