'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _form = require('./common/form');

var _form2 = _interopRequireDefault(_form);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var updateContext = function updateContext(context) {
  if ('forceUpdate' in context && typeof context.forceUpdate === 'function') {
    context.forceUpdate();
  }
};

var formCreate = function formCreate(inputAttr) {
  return function (target, propertyKey, descriptor) {
    target.__formCreators = target.__formCreators || [];

    target.__formCreators.push(function (context) {
      var options = context[propertyKey];
      var form = new _form2.default(options);
      form.on('change', function () {
        updateContext(context);
      });
      form.on('submit', function () {
        updateContext(context);
      });
      context[propertyKey] = form;
    });

    return null;
  };
};

exports.default = formCreate;